;7am News Wire Ticker
;1.0
;Pasmal <pasmal@zaz.net>
;http://zaz.net

alias 7am { 
  ;options: c = clear @7am, t = ticker output
  ;output options: @ = @7am, d = dialog, n = none (works well with t for ticker)
  ;other options: f = read from file, i = internal use only - makes it find the sub sections and display on reuqested dialog
  if ($1 == $null) && ($isid == $false) {
    ;possible other options: output direction, silent, custom, dialog, file.to.use
    echo 2 -a * /7am: insufficient paramters. /7am <-nz|us|uk|au|world>:[@cdiftn] [Sections|All]
    echo 2 -a * /7am: example /7am -nz:d ALL
    return
  }
  if (i isin $deltok($1,1,58)) unset %7am.list.wires
  if (d isin $deltok($1,1,58)) {
    if ($dialog(7am.content)) did -r 7am.content 3 | else dialog -mdo 7am.content 7am.content
  }
  if (f isin $deltok($1,1,58)) { 
    if ($dialog(7am.ticker)) dialog -c 7am.ticker
    if ($isfile($scriptdir7am.dat) == $false) && ($isid == $false) { echo 2 -a * /7am: data file not found, please create one first! | return }
    saveini $scriptdir7am.dat
    echo 3 -a *** Starting download of www.7am.com headlines for the ticker...
    set %7am.file $lines($scriptdir7am.dat)
    set %7am.file.count 2
    set %7am.file.current $read -l2 $scriptdir7am.dat
    ;ini format: /writeini 7am wiretype[nz,au,us,uk,world] params[ALL POST etc...]
    sockopen 7am $+ $gettok(%7am.file.current,1,61) www.7am.com 80 
    sockmark 7am $+ $gettok(%7am.file.current,1,61) $deltok($1,1,58) $+ . $+ $iif($deltok(%7am.file.current,1,61) != $null,$deltok(%7am.file.current,1,61),all)
    echo 3 -a *** Now downloading headlines for $gettok(%7am.file.current,1,61) $chr(91) $+ $deltok(%7am.file.current,1,61) $+ $chr(93)
    return 
  }
  sockopen 7am $+ $remove($gettok($1,1,58),-) www.7am.com 80 
  sockmark 7am $+ $remove($gettok($1,1,58),-) $iif($deltok($1,1,58) != $null,$deltok($1,1,58),0) $+ . $+ $iif($2- != $null,$2-,all)
}
;This alias just opens a socket to www.7am.com - a news orientated web based service.
on *:SOCKOPEN:7am*: {
  if ($sockerr > 0) { echo 4 -a * /7am: A socket error occured ( $+ $sockerr $+ ) | return }
  write -c 7am.txt
  ;Once the socket is opened, we need to request the file that contains the news headers.
  ;Unlucky for us, its in a HTML file so once we start recieving it, we need to do a fair bit of parsing.
  sockwrite -n $sockname GET $news.ref($right($sockname,-3)) HTTP/1.1
  sockwrite -n $sockname Host: www.7am.com
  sockwrite -n $sockname Connect: Keep-alive
  sockwrite $sockname $lf
  if (c isin $gsock($sockname,1)) clear @7am
  if (d isin $gsock($sockname,1)) && ($dialog(7am.content)) did -r 7am.content 3
  if (@ isin $gsock($sockname,1)) {
    window @7am
    ;Creates a @window to display the headlines
    aline @7am Requesting $news.type($right($sockname,-3)) Headlines...
  }
  if (d isin $gsock($sockname,1)) {
    did -a 7am.content 2 Wire: $news.type($right($sockname,-3))
  }
  if (t isin $gsock($sockname,1)) {
    if ($isdir($scriptdir7am) == $false) mkdir $scriptdir7am
    var %7am.temp.isdir = $scriptdir7am $+ $left($replace($news.ref($right($sockname,-3)),/,\),-1)
    if ($isdir(%7am.temp.isdir) == $false) mkdir %7am.temp.isdir
    var %7am.temp.checkfiles = $findfile(%7am.temp.isdir,*.txt,0)
    if ($findfile(%7am.temp.isdir,*.txt,0)) {
      var %7am.temp.checkfiles.count = 0
      :start
      inc %7am.temp.checkfiles.count
      .remove $findfile(%7am.temp.isdir,*.txt,1)
      ;echo -s    remove $findfile(%7am.temp.isdir,*.txt,%7am.temp.checkfiles.count)
      ;note to change to 1
      if (%7am.temp.checkfiles.count < %7am.temp.checkfiles) goto start
    }
  }
}
;-------------------- Sockmark editing and viewing aliases
alias gsock {
  ; options.sections of wires to look for
  ; $gsock(sockname,N)
  if ($sock($1).ip != $null) && ($2 != $null) {
    return $gettok($sock($1).mark,$2,46)
  }
  return
}
alias rsock {
  ;/rsock sockname N new-value
  if ($sock($1).ip != $null) && ($3 != $null) {
    sockmark $1 $puttok($sock($1).mark,$3-,$2,46)
} }
;-------------------- End of Sockmark editing and viewing ailases
alias -l news.type return $reptok($reptok($reptok($reptok($reptok($1-,nz,New Zealand Wires,32),au,Australian Wires,32),uk,UK Wires,32),world,World Wires,32),us,US BizWire,32)
alias -l news.ref return $reptok($reptok($reptok($reptok($reptok($1-,nz,/nzwires/,32),au,/auswires/,32),uk,/ukwires/,32),world,/worldwires/,32),us,/usbizwire/,32)
alias -l news.ref.rev return $reptok($reptok($reptok($reptok($reptok($1-,/nzwires/,nz,32),/auswires/,au,32),/ukwires/,uk,32),/worldwires/,world,32),/usbizwire/,us,32)
on *:SOCKREAD:7am*: {
  if ($sockerr > 0) { echo 4 -a * /7am: A socket error occured ( $+ $sockerr $+ ) | return }
  sockread %7am
  tokenize 32 %7am
  if ($1) {
    write 7am.txt $1-
    ;ignore this crap code...
    ;asc 60 = <
    if (i isin $gsock($sockname,1)) && ($wildtok($1-,a href="#*,1,60)) {
      set %7am.list.wires %7am.list.wires $gettok($gettok($wildtok($1-,a href="#*,1,60),2,35),1,34)
      return
    }
    if ($wildtok($1-,a name="*">,1,60)) {
      if (i isin $gsock($sockname,1)) { 
        var %7am.temp.i = 7am.settings.add. $+ $news.ref.rev($right($sockname,-3))
        if ($dialog(%7am.temp.i)) {
          did -r %7am.temp.i 5
          did -a %7am.temp.i 5 All
          var %7am.temp.i.total = $numtok(%7am.list.wires,32)
          var %7am.temp.i.count = 0
          :start.i
          inc %7am.temp.i.count
          did -a %7am.temp.i 5 $gettok(%7am.list.wires,%7am.temp.i.count,32)
          if (%7am.temp.i.count < %7am.temp.i.total) goto start.i
          dialog -t %7am.temp.i [http://www.7am.com] 7am News Wire Ticker Settings: Add Section
          sockclose $sockname | return       
        }
      }
      set %7am.temp.source $wildtok($1-,a name="*">,1,60)
      set %7am.temp.source $gettok(%7am.temp.source,2,34)
      if (d isin $gsock($sockname,1)) && ($dialog(7am.content)) {
        if ($istok($gsock($sockname,2),%7am.temp.source,32)) || ($istok($gsock($sockname,2),all,32)) {
          did -a 7am.content 3 ---
          did -a 7am.content 3 --- Start of %7am.temp.source --- 
        }
      }
    }    
    if (@ isin $gsock($sockname,1)) {
      if ($istok($gsock($sockname,2),%7am.temp.source,32)) || ($istok($gsock($sockname,2),all,32)) aline @7am Start of 2 $+ %7am.temp.source $+  section
    }
  }
  if (</ul> == $1-) && (%7am.temp.source != $null) { 
    if (d isin $gsock($sockname,1)) && ($dialog(7am.content)) {
      if ($istok($gsock($sockname,2),%7am.temp.source,32)) || ($istok($gsock($sockname,2),all,32)) {
        did -a 7am.content 3 ---
        did -a 7am.content 3 --- End of %7am.temp.source --- 
      }
    }
    if (@ isin $gsock($sockname,1)) {
      if ($istok($gsock($sockname,2),%7am.temp.source,32)) || ($istok($gsock($sockname,2),all,32)) aline @7am End of 2 $+ %7am.temp.source $+  section 
    }
    unset %7am.temp.source 
  }
  if (<LI><A?HREF="*>*</A> iswm $1-) && (($istok($gsock($sockname,2),%7am.temp.source,32)) || ($istok($gsock($sockname,2),all,32))) {
    var %7am.temp = $deltok($3,1,62) $4-
    if (@ isin $gsock($sockname,1)) aline @7am $remove(%7am.temp,</A>,</I>,<I>) (2 $+ $deltok($2,1,34) $+ )
    if (d isin $gsock($sockname,1)) && ($dialog(7am.content)) did -a 7am.content 3 $remove(%7am.temp,</A>,</I>,<I>) ( $+ $deltok($2,1,34) $+ )
    if (t isin $gsock($sockname,1)) {
      var %7am.temp.file = $scriptdir7am $+ $replace($news.ref($right($sockname,-3)),/,\) $+ %7am.temp.source $+ .txt
      write %7am.temp.file $remove(%7am.temp,</A>,</I>,<I>) $+ $chr(1) $+ $deltok($2,1,34)
    }
  }
}
on *:SOCKCLOSE:7am*: {
  if (@ isin $gsock($sockname,1))  { aline @7am - | aline @7am End Of News from 2http://www.7am.com/ }
  if (f isin $gsock($sockname,1)) {
    if (%7am.file.count >= %7am.file) { unset %7am.file.count %7am.file %7am.file.current | echo 3 -a *** Ticker data file download complete. Type /7am.ticker to start the ticker. | return }
    inc %7am.file.count
    set %7am.file.current $read -l [ $+ [ %7am.file.count ] ] $scriptdir7am.dat
    ;ini format: /writeini 7am wiretype[nz,au,us,uk,world] params[ALL POST etc...]
    echo 3 -a *** Now downloading headlines for $gettok(%7am.file.current,1,61) $chr(91) $+ $gettok(%7am.file.current,2,61) $+ $chr(93)
    sockopen 7am $+ $gettok(%7am.file.current,1,61) www.7am.com 80 
    sockmark 7am $+ $gettok(%7am.file.current,1,61) $gsock($sockname,1) $+ . $+ $iif($deltok(%7am.file.current,1,61) != $null,$deltok(%7am.file.current,1,61),all)
  }
}
on *:DIALOG:7am.content:dclick:*: {
  if ($did == 3) && (http:// isin $did($did,$did($did).sel).text) {
    dialog -n 7am.content
    run $left($deltok($did($did,$did($did).sel).text,1,40),-1)
  }
}
on *:DIALOG:7am.content:sclick:*: {
  if ($did == 11) && (http:// isin $did($did,$did($did).sel).text) {
    dialog -n 7am.content
    run $left($deltok($did($did,$did($did).sel).text,1,40),-1)
  }
  if ($did == 111) 7am.settings
  if ($did == 1) { set %7am.content.x $dialog($dname).x | set %7am.content.y $dialog($dname).y }
}
on *:DIALOG:7am.content:init:0: if (%7am.setting.14) && (%7am.content.x) dialog -bs 7am.content %7am.content.x %7am.content.y 230 140
dialog 7am.content {
  title "7am News Wires [http://www.7am.com]"
  size -1 -1 230 140
  option dbu

  button "&OK",1,190 10 40 45,cancel
  button "&URL",11,190 58 40 45
  button "&Settings",111,190 105 40 45
  box "Wire: ",2, 5 5 180 145
  list 3,10 13 170 140
}
dialog 7am.ticker {
  title "[http://www.7am.com] 7am News Wires Ticker: "
  size 100 1 313 0
  option dbu
  button "&URL",1,243 2 30 10, default
  list 2,2 2 240 12
  combo 3,2 12 304 190, drop
  button "&Settings",4,275 2 30 10
  button "hidden",5,400 30 1 1, cancel
  button "+",6,307 2 8 10
  button "[&]",7,307 12 8 10
}
alias 7am.ticker {
  if ($dialog(7am.ticker)) { dialog -r 7am.ticker } | else { dialog -mdo 7am.progress 7am.progress }
}
alias 7am.settings  if ($dialog(7am.settings)) { dialog -r 7am.settings } | else  dialog -mdo 7am.settings 7am.settings
alias 7am.content  if ($dialog(7am.settings)) { dialog -r 7am.settings } | else  dialog -mdo 7am.content 7am.content
on *:DIALOG:7am.ticker:sclick:*: {
  if ($did == 3) && (http:// isin $did($did,$did($did).sel).text) run $left($wildtok($did($did,$did($did).sel).text,http://*,1,40),-1)
  if ($did == 1) && (%7am.ticker.url) run %7am.ticker.url
  if ($did == 4) 7am.settings
  if ($did == 5) {
    set %7am.ticker.x $dialog($dname).x 
    set %7am.ticker.y $dialog($dname).y
    set %7am.ticker.extended $iif(- isin $did(6),1,0)
  }
  if ($did == 6) {
    if (%7am.ticker.extended == $null) set %7am.ticker.extended 1
    var %7am.ticker.type = $iif(%7am.ticker.extended == 1,-1,1)
    var %7am.ticker.extend = $iif(%7am.ticker.extended == 1,11,0)
    var %7am.ticker.extend.count = $iif(%7am.ticker.extended == 1,11,0)
    :start
    inc %7am.ticker.extend.count %7am.ticker.type
    dialog -bs $dname $dialog($dname).x $dialog($dname).y 313 %7am.ticker.extend.count
    if (%7am.ticker.type == -1) && (%7am.ticker.extend.count > 0) goto start
    if (%7am.ticker.type == 1) && (%7am.ticker.extend.count < 11) goto start
    set %7am.ticker.extended $iif(%7am.ticker.type == 1,1,0)
    did -a $dname 6 $iif(%7am.ticker.type == 1,-,+)
  }
  if ($did == 7) {
    if (%7am.ticker.showmirc == $null) set %7am.ticker.showmirc -t
    showmirc %7am.ticker.showmirc
    set %7am.ticker.showmirc $iif(%7am.ticker.showmirc == -t,-s,-t)
  }
}
on *:DIALOG:7am.ticker:init:0: {
  if (%7am.ticker.x) && (%7am.setting.14) dialog -bs 7am.ticker %7am.ticker.x %7am.ticker.y 313 $iif(%7am.ticker.extended == 1,11,0)
  did -a $dname 6 $iif(%7am.ticker.extended == 1,-,+)
  .timer7am.ticker -o 0 %7am.ticker.interval 7am.ticker.update
  7am.ticker.init
}
alias 7am.ticker.update {
  if ($dialog(7am.ticker) == $Null) .timer7am.ticker off
  if ($lines($scriptdir7am.dat)) && ($dialog(7am.ticker)) {
    if (%7am.ticker.current.file.to.use >= %7am.ticker.total.files.to.use) { 
      set %7am.ticker.current.file.to.use 1
      set %7am.ticker.current.line.to.use 0
    }
    :start
    inc %7am.ticker.current.line.to.use
    var %7am.temp.ticker.file = $gettok(%7am.ticker.files.to.read,%7am.ticker.current.file.to.use,32)
    var %7am.temp.ticker.file  = $scriptdir7am $+ %7am.temp.ticker.file
    if ($lines(%7am.temp.ticker.file)) {
      var %7am.temp.ticker.line = $read -nl [ $+ [ %7am.ticker.current.line.to.use ] ] %7am.temp.ticker.file
      var %7am.ticker.total.lines.in.file = $lines(%7am.temp.ticker.file)
      dialog -t 7am.ticker [http://www.7am.com] 7am News Wire Ticker: $left($right($gettok(%7am.ticker.files.to.read,%7am.ticker.current.file.to.use,32),-1),-4) $chr(91) $+ %7am.ticker.current.line.to.use $+ / $+ %7am.ticker.total.lines.in.file $+ , %7am.ticker.current.file.to.use $+ / $+ %7am.ticker.total.files.to.use $+ $chr(93)
      did -r 7am.ticker 2
      set %7am.ticker.url $deltok(%7am.temp.ticker.line,1,1)
      did -a 7am.ticker 2 $left($nopath(%7am.temp.ticker.file),-4) $+ : $gettok(%7am.temp.ticker.line,1,1) ( $+ $iif(7am.com/cgi-bin/ isin %7am.ticker.url,$deltok(%7am.ticker.url,1,63),%7am.ticker.url) $+ )
    }
    if (%7am.ticker.current.line.to.use >= %7am.ticker.total.lines.in.file) || ($isfile(%7am.temp.ticker.file) == $false) {
      inc %7am.ticker.current.file.to.use
      set %7am.ticker.current.line.to.use 0
    }
  }
}
alias -l 7am.filegen {
  unset %7am.ticker.files.to.read
  var %7am.ticker.lines = $lines($scriptdir7am.dat)
  var %7am.ticker.count 1
  :start.filegen
  inc %7am.ticker.count
  var %7am.temp.read = $read -nl [ $+ [ %7am.ticker.count ] ]  $scriptdir7am.dat
  if (ALL isin $deltok(%7am.temp.read,1,61)) {
    var %7am.temp.count = 0
    var %7am.temp.dir = $scriptdir7am $+ $left($replace($news.ref($gettok(%7am.temp.read,1,61)),/,\),-1)
    var %7am.temp.loop = $findfile(%7am.temp.dir,*.txt,0)
    :start.findfile
    inc %7am.temp.count
    var %7am.temp.read3 = $remove($findfile(%7am.temp.dir,*.txt,%7am.temp.count),$scriptdir7am)
    set %7am.ticker.files.to.read %7am.ticker.files.to.read %7am.temp.read3
    if (%7am.temp.count < %7am.temp.loop) goto start.findfile
    goto bypass1
  }
  var %7am.temp.count = 0
  var %7am.temp.loop = $numtok($deltok(%7am.temp.read,1,61),32)
  :start.gettok
  inc %7am.temp.count
  var %7am.temp.read3 = $replace($news.ref($gettok(%7am.temp.read,1,61)),/,\) $+ $gettok($deltok(%7am.temp.read,1,61),%7am.temp.count,32) $+ .txt
  set %7am.ticker.files.to.read %7am.ticker.files.to.read %7am.temp.read3
  if (%7am.temp.count < %7am.temp.loop) goto start.gettok
  :bypass1
  if (%7am.ticker.count < %7am.ticker.lines) goto start.filegen
}
alias 7am.ticker.init {
  if ($lines($scriptdir7am.dat))  {
    ; 7am.filegen
    var %7am.temp.count = 0
    var %7am.temp.total = $numtok(%7am.ticker.files.to.read,32)
    set %7am.ticker.total.files.to.use %7am.temp.total
    set %7am.ticker.current.file.to.use 1
    set %7am.ticker.current.line.to.use 0
    var %7am.temp.loadbuf.count2 = 0
    ;%7am.temp.total.linesb
    if ($dialog(7am.progress)) { did -r 7am.progress 2 | did -a 7am.progress 2 Loading: }
    :start.loadbuf
    inc %7am.temp.count
    var %7am.temp.loadbuf.file = $gettok(%7am.ticker.files.to.read,%7am.temp.count,32)
    var %7am.temp.loadbuf.file = $scriptdir7am $+ %7am.temp.loadbuf.file
    var %7am.temp.loadbuf.lines = $lines(%7am.temp.loadbuf.file)
    if (%7am.temp.loadbuf.lines) {
      var %7am.temp.loadbuf.count = 0
      did -a 7am.ticker 3 --------- $left($nopath(%7am.temp.loadbuf.file),-4) ---------
      :start.loadbuf.lines
      inc %7am.temp.loadbuf.count
      inc %7am.temp.loadbuf.count2
      if ($dialog(7am.progress)) {
        did -r 7am.progress 2 | did -a 7am.progress 2 Loading: $left($nopath(%7am.temp.loadbuf.file),-4) $chr(91) $+ %7am.temp.loadbuf.count2 $+ / $+ %7am.temp.total.linesb $+ $chr(93) 
        var %7am.temp.percent = $calc(%7am.temp.loadbuf.count2 / %7am.temp.total.linesb)
        dialog -t 7am.progress 7am Ticker Loading... $round($calc(%7am.temp.percent * 100),1) $+ $chr(37)
        var %7am.temp.percent = $round($calc(%7am.temp.percent * 40),0)
        if (%7am.temp.percent) && ($did(7am.progress,%7am.temp.percent).visible == $false) did -v 7am.progress %7am.temp.percent
      }
      var %7am.temp.loadbuf.data = $read -nl [ $+ [ %7am.temp.loadbuf.count ] ] %7am.temp.loadbuf.file
      ;$iif(7am.com/cgi-bin/ isin %7am.ticker.url,$deltok(%7am.ticker.url,1,63),%7am.ticker.url)
      if (7am.com/cgi-bin/ isin %7am.ticker.url) var %7am.quickie = $deltok($deltok(%7am.temp.loadbuf.data,1,1),1,63) | else var %7am.quickie = $deltok(%7am.temp.loadbuf.data,1,1)
      if (%7am.temp.loadbuf.data) did -a 7am.ticker 3 $gettok(%7am.temp.loadbuf.data,1,1) ( $+ %7am.quickie $+ )
      if (%7am.temp.loadbuf.count < %7am.temp.loadbuf.lines) goto start.loadbuf.lines
    }
    if (%7am.temp.count < %7am.temp.total) goto start.loadbuf
  }
  dialog -x 7am.progress
}
dialog 7am.settings {
  title "[http://www.7am.com] 7am News Wire Ticker Settings"
  size -1 -1 380 120
  option dbu

  box "Read news from:",2,5 5 130 125
  list 3,10 15 120 110,sort

  box "Avaliable sections:",4, 160 5 130 125
  list 5,165 15 120 110,sort

  button "&+",6, 137 15 20 40
  button "&-",7,137 60 20 40
  button "&Edit",8,137 105 20 25

  box "Options",9,293 5 85 125
  check "&Start Ticker on Startup",10,298 15 75 10
  check "&Download News on Startup",11,298 25 75 10
  text "Ticker Scroll Interval (secs)",12,298 40 75 10
  combo 13, 335 50 30 120, drop
  check "Save Window Positions",14,298 65 75 10

  button "&Help",15,298 105 75 20
  button "&Done",1,298 83 75 20,cancel
}
dialog 7am.settings.add {
  title "[http://www.7am.com] 7am News Wire Ticker Settings: Add Section"
  size -1 -1 240 90
  option dbu

  box "Read news from:",2, 5 5 90 90
  list 3,10 15 80 80,sort

  box "Avaliable sections:",4, 120 5 90 90
  list 5,125 15 80 80,sort

  button "&+",6, 97 15 20 35
  button "&-",7,97 55 20 35

  button "&Refresh",8,215 15 25 35
  button "&Save",9,215 55 25 35, ok
}
on *:DIALOG:7am.settings.add.*:init:0:{
  7am - $+ $gettok($dname,4,46) $+ :i
  if ($readini $scriptdir7am.dat 7am $gettok($dname,4,46) != $null) {
    var %7am.temp.addsetting.data = $readini $scriptdir7am.dat 7am $gettok($dname,4,46)
    var %7am.temp.addsetting.total = $numtok(%7am.temp.addsetting.data,32)
    var %7am.temp.addsetting.count = 0
    :start
    inc %7am.temp.addsetting.count
    did -a $dname 3 $gettok(%7am.temp.addsetting.data,%7am.temp.addsetting.count,32)
    if (%7am.temp.addsetting.count < %7am.temp.addsetting.total) goto start
  }
}
on *:DIALOG:7am.settings.add.*:dclick:*: {
  if ($did == 5) && ($did(5,$did(5).sel).text) {
    var %7am.temp.addsetting.check = $did(3).lines
    var %7am.temp.addsetting.check2 = 0
    :start.2
    inc %7am.temp.addsetting.check2
    if ($istok($did(3,%7am.temp.addsetting.check2).text,$gettok($did(5,$did(5).sel).text,1,32),32)) goto exit.2
    if (%7am.temp.addsetting.check2 < %7am.temp.addsetting.check) goto start.2
    did -a $dname 3 $did(5,$did(5).sel).text
    :exit.2
    did -d $dname 5 $did(5).sel
  }
  if ($did == 3) && ($did(3,$did(3).sel).text) {
    var %7am.temp.addsetting.check = $did(5).lines
    var %7am.temp.addsetting.check2 = 0
    :start.3
    inc %7am.temp.addsetting.check2
    if ($istok($did(5,%7am.temp.addsetting.check2).text,$gettok($did(3,$did(3).sel).text,1,32),32)) goto exit.3
    if (%7am.temp.addsetting.check2 < %7am.temp.addsetting.check) goto start.3
    did -a $dname 5 $did(3,$did(3).sel).text
    :exit.3
    did -d $dname 3 $did(3).sel
  }
}
on *:DIALOG:7am.settings.add.*:sclick:*: {
  if ($did == 8) { 
    7am - $+ $gettok($dname,4,46) $+ :i
    dialog -t $dname Please wait... Scanning file for avaliable sections
  }
  if ($did == 6) && ($did(5,$did(5).sel).text) {
    var %7am.temp.addsetting.check = $did(3).lines
    var %7am.temp.addsetting.check2 = 0
    :start.2
    inc %7am.temp.addsetting.check2
    if ($istok($did(3,%7am.temp.addsetting.check2).text,$gettok($did(5,$did(5).sel).text,1,32),32)) goto exit.2
    if (%7am.temp.addsetting.check2 < %7am.temp.addsetting.check) goto start.2
    did -a $dname 3 $did(5,$did(5).sel).text
    :exit.2
    did -d $dname 5 $did(5).sel
  }
  if ($did == 7) && ($did(3,$did(3).sel).text) {
    var %7am.temp.addsetting.check = $did(5).lines
    var %7am.temp.addsetting.check2 = 0
    :start.3
    inc %7am.temp.addsetting.check2
    if ($istok($did(5,%7am.temp.addsetting.check2).text,$gettok($did(3,$did(3).sel).text,1,32),32)) goto exit.3
    if (%7am.temp.addsetting.check2 < %7am.temp.addsetting.check) goto start.3
    did -a $dname 5 $did(3,$did(3).sel).text
    :exit.3
    did -d $dname 3 $did(3).sel
  }
  if ($did == 9) && ($did(3).lines) {
    var %7am.temp.addsetting.total = $did(3).lines
    var %7am.temp.addsetting.count = 0
    :start
    inc %7am.temp.addsetting.count
    var %7am.temp.addsetting.data = %7am.temp.addsetting.data $did(3,%7am.temp.addsetting.count).text
    if (%7am.temp.addsetting.count < %7am.temp.addsetting.total) goto start
    writeini $scriptdir7am.dat 7am $gettok($dname,4,46) %7am.temp.addsetting.data
    saveini $scriptdir7am.dat
    7am.update.settings
  }
}
alias -l am.full {
  if ($2) { return $reptok($reptok($reptok($reptok($reptok($1,nz,2,1,32),au,1,1,32),uk,3,1,32),world,5,1,32),us,4,132) } 
  return $reptok($reptok($1-,nz,NZ New Zealand,32),au,AU Australia,32)
}
on *:DIALOG:7am.settings:dclick:*:{
  if ($did == 5) && ($did(5,$did(5).sel).text) dialog -mdo 7am.settings.add. [ $+ [ $gettok($did(5,$did(5).sel).text,1,32) ] ] 7am.settings.add
  if ($did == 3) && ($did(3,$did(3).sel).text) { remini $scriptdir7am.dat 7am $gettok($did(3,$did(3).sel).text,1,32) | saveini $scriptdir7am.dat | 7am.update.settings }
}
on *:DIALOG:7am.settings:init:0:{
  7am.update.settings
  did -a $dname 13 1) 0.25
  did -a $dname 13 2) 0.5
  did -a $dname 13 3) 0.75
  var %7am.temp.init = 0
  :start
  inc %7am.temp.init
  did -a $dname 13 $calc(%7am.temp.init + 3) $+ ) %7am.temp.init
  if (%7am.temp.init < 30) goto start
  if (%7am.setting.10) did -c 7am.settings 10
  if (%7am.setting.11) did -c 7am.settings 11
  if (%7am.setting.14) did -c 7am.settings 14
  if (%7am.setting.duration) did -c 7am.settings 13 %7am.setting.duration
  if (%7am.settings.x) && (%7am.setting.14) dialog -bs 7am.settings %7am.settings.x %7am.settings.y 380 130
}
alias -l 7am.update.settings {
  did -r 7am.settings 3
  did -r 7am.settings 5
  if ($readini $scriptdir7am.dat 7am au == $null) did -a 7am.settings 5 AU Australia | else did -a 7am.settings 3 AU Australia $chr(91) $+ $readini $scriptdir7am.dat 7am au $+ $chr(93)
  if ($readini $scriptdir7am.dat 7am nz == $null) did -a 7am.settings 5 NZ New Zealand  | else did -a 7am.settings 3 NZ New Zealand $chr(91) $+ $readini $scriptdir7am.dat 7am nz $+ $chr(93)
  if ($readini $scriptdir7am.dat 7am uk == $null) did -a 7am.settings 5 UK  | else did -a 7am.settings 3 UK $chr(91) $+ $readini $scriptdir7am.dat 7am uk $+ $chr(93)
  if ($readini $scriptdir7am.dat 7am us == $null) did -a 7am.settings 5 US  | else did -a 7am.settings 3 US $chr(91) $+ $readini $scriptdir7am.dat 7am us $+ $chr(93)
  if ($readini $scriptdir7am.dat 7am world == $null) did -a 7am.settings 5 World  | else did -a 7am.settings 3 World $chr(91) $+ $readini $scriptdir7am.dat 7am world $+ $chr(93)
}
on *:LOAD: {
if ($version < 5.61) { echo 4 -a * /7am: You must be using mIRC 5.61 or higher. Goto 2http://www.mirc.co.uk | timer 1 1 unload -rs $script }
  echo 3 -a * /7am: Script Loaded. You can access it through the Channel, Status, and Menubar popups.
  if ($isfile($mircdirblock.bmp) == $false) echo 4 -a * /7am: Warning: You need to place block.bmp in $mircdir in order for this script to work!
}
on *:START: {
  if (%7am.setting.10) .timer 1 1 7am.ticker
  if (%7am.setting.11) .timer 1 1 7am 0:ft
}
on *:DIALOG:7am.settings:sclick:*: {
  if ($did == 1) {
    set %7am.settings.x $dialog($dname).x
    set %7am.settings.y $dialog($dname).y
  }
  if ($did == 15) && ($isfile($scriptdir7am-help.txt)) run $scriptdir7am-help.txt
  if ($did == 13) { set %7am.setting.duration $gettok($did($did,$did($did).sel).text,1,41) | set %7am.ticker.interval $gettok($did($did,$did($did).sel).text,2,32) }
  if ($istok(10 11 14,$did,32)) set %7am.setting. [ $+ [ $did ] ] $did($did).state
  if ($did == 6) && ($did(5,$did(5).sel).text) dialog -mdo 7am.settings.add. [ $+ [ $gettok($did(5,$did(5).sel).text,1,32) ] ] 7am.settings.add
  if ($did == 7) && ($did(3,$did(3).sel).text) {  remini $scriptdir7am.dat 7am $gettok($did(3,$did(3).sel).text,1,32) | saveini $scriptdir7am.dat | 7am.update.settings }
  if ($did == 8) && ($did(3,$did(3).sel).text) dialog -mdo 7am.settings.add. [ $+ [ $gettok($did(3,$did(3).sel).text,1,32) ] ] 7am.settings.add
}
dialog 7am.progress {
  title "7am Ticker Loading..."
  size -1 -1 300 60
  button "OK",1,1 1 1 1, hide ok
  text "Loading:",2,5 5 290 20
  icon 3, 5 35 5 14, block.bmp, hide
  icon 4, 12 35 5 14, block.bmp, hide 
  icon 5, 19 35 5 14, block.bmp, hide
  icon 6, 26 35 5 14, block.bmp, hide
  icon 7, 33 35 5 14, block.bmp, hide
  icon 8, 40 35 5 14, block.bmp, hide
  icon 9, 47 35 5 14, block.bmp, hide
  icon 10, 54 35 5 14, block.bmp, hide
  icon 11, 61 35 5 14, block.bmp, hide
  icon 12, 68 35 5 14, block.bmp, hide
  icon 13, 75 35 5 14, block.bmp, hide
  icon 14, 82 35 5 14, block.bmp, hide
  icon 15, 89 35 5 14, block.bmp, hide
  icon 16, 96 35 5 14, block.bmp, hide
  icon 17, 103 35 5 14, block.bmp, hide
  icon 18, 110 35 5 14, block.bmp, hide
  icon 19, 117 35 5 14, block.bmp, hide
  icon 20, 124 35 5 14, block.bmp, hide
  icon 21, 131 35 5 14, block.bmp, hide
  icon 22, 138 35 5 14, block.bmp, hide
  icon 23, 145 35 5 14, block.bmp, hide
  icon 24, 152 35 5 14, block.bmp, hide
  icon 25, 159 35 5 14, block.bmp, hide
  icon 26, 166 35 5 14, block.bmp, hide
  icon 27, 173 35 5 14, block.bmp, hide
  icon 28, 180 35 5 14, block.bmp, hide
  icon 29, 187 35 5 14, block.bmp, hide
  icon 30, 194 35 5 14, block.bmp, hide
  icon 31, 201 35 5 14, block.bmp, hide
  icon 32, 208 35 5 14, block.bmp, hide
  icon 33, 215 35 5 14, block.bmp, hide
  icon 34, 222 35 5 14, block.bmp, hide
  icon 35, 229 35 5 14, block.bmp, hide
  icon 36, 236 35 5 14, block.bmp, hide
  icon 37, 243 35 5 14, block.bmp, hide
  icon 38, 250 35 5 14, block.bmp, hide
  icon 39, 257 35 5 14, block.bmp, hide
  icon 40, 264 35 5 14, block.bmp, hide
}
on *:DIALOG:7am.progress:init:0: {
  .timer -m 1 1 7am.call.progress
}
alias -l 7am.call.progress {
  7am.filegen
  var %7am.temp.count = 0
  var %7am.temp.total = $numtok(%7am.ticker.files.to.read,32)
  set %7am.ticker.total.files.to.use %7am.temp.total
  set %7am.ticker.current.file.to.use 1
  set %7am.ticker.current.line.to.use 0
  set %7am.temp.total.linesb 0
  :start.loadbuf
  inc %7am.temp.count
  var %7am.temp.loadbuf.file = $gettok(%7am.ticker.files.to.read,%7am.temp.count,32)
  var %7am.temp.loadbuf.file = $scriptdir7am $+ %7am.temp.loadbuf.file
  var %7am.temp.loadbuf.lines = $lines(%7am.temp.loadbuf.file)
  if (%7am.temp.loadbuf.lines) {
    inc %7am.temp.total.linesb $lines(%7am.temp.loadbuf.file)
    did -r 7am.progress 2
    did -a 7am.progress 2 Init: Prescanning $nopath(%7am.temp.loadbuf.file) $+ ... $lines(%7am.temp.loadbuf.file) $+ / $+ %7am.temp.total.linesb
  }
  if (%7am.temp.count < %7am.temp.total) goto start.loadbuf
  :bypass
  did -r 7am.progress 2
  did -a 7am.progress 2 Init: Complete...
  did -v 7am.progress 3
  .timer -m 1 1  dialog -mdo 7am.ticker 7am.ticker
}
menu channel,menubar,status { 
  7am News 
  .Start Ticker: 7am.ticker
  .Reload Ticker Files: echo 3 -a *** Reloading ticker data files... this may take a few minutes if you have a slow connection | 7am 0:ft
  .-
  .Ticker Settings: 7am.settings
  .Version Check: run http://zaz.net/scripts/addons.html
  .Help: run 7am-help.txt
  .-
  .Unload: {
    echo 3 -a * /7am: Unsetting variables:
    unset -s %7am.*
    if ($isfile($scriptdir7am.dat)) { 
      echo 3 -a * /7am: Removing Master Data File:
      remove $scriptdir7am.dat
    } 
    echo 3 -a * /7am: Please remove $scriptdir7am and all its contents $+ . 
    echo 3 -a *  /7am: Unloading Script:
    .timer 1 1 unload -rs $script
  }
}
